
import wget
from os.path import isfile, join, isdir
from os import rename, mkdir, walk

dates = {'2013': {'07': 31, '08': 31, '09': 30, '10': 31, '11': 30, '12': 31},
         '2014': {'01': 31, '02': 28, '03': 31, '04': 30, '05': 31, '06': 30}}


total_files_down = 0
for dirpath, dirnames, filenames in walk('.'):
    total_files_down += len([f for f in filenames if f.endswith('.nc4')])
total_files = 365 * 24

while total_files_down < total_files:
    try:
        for year in dates:
            for month in dates[year]:
                for day in range(1, dates[year][month] + 1):
                    for hour in range(24):
                        day_str = f'{day:02d}'
                        day_dir = f'D{day_str}/'
                        hour_str = f'{hour:02d}00'
                        base = 'https://portal.nccs.nasa.gov/datashare/G5NR-Chem/Heracles/12.5km/DATA/0.625_deg/inst/'
                        no2_dir = base + f'inst1_3d_TRCNO2_Cv/Y{year}/M{month}/'
                        no2_file = f'g5nr-chem-c720.inst1_3d_TRCNO2_Cv.{year}{month}{day_str}_{hour_str}z.nc4'    

                        save_dir = f'{year}{month}'
                        if not isdir(save_dir):
                            mkdir(save_dir)

                        if not isdir(join(save_dir, day_str)):
                            mkdir(join(save_dir, day_str))

                        if not isfile(join(join(save_dir, day_str), no2_file)):
                            url = no2_dir + day_dir + no2_file
                            print(f'\ndownloading file {total_files_down} out of {total_files} ({1e2*total_files_down/total_files:.1f}%)')
                            wget.download(url)
                            rename(no2_file, join(join(save_dir, day_str), no2_file))
                            total_files_down += 1
    except KeyboardInterrupt:
        break
    except:
        pass
